<template>
    <div class="custom-table">
        <el-table
            :data="tableData"
            border
            style="width: 100%"
            v-loading="loading">
            <el-table-column type="index" align="center" label="序号" width="80" />
            <el-table-column prop="enforce_org_name" show-overflow-tooltip label="设置机构" align="center" />
            <el-table-column prop="risk_num" show-overflow-tooltip label="火灾高危单位" />
            <el-table-column prop="focus_num" show-overflow-tooltip label="消防安全重点单位" />
            <el-table-column prop="police_num" show-overflow-tooltip label="一般单位" align="center" />
            <el-table-column prop="other_num" show-overflow-tooltip label="其他单位" align="center" />
            <el-table-column prop="task_month" show-overflow-tooltip label="任务生成月份" align="center" />
            <el-table-column prop="task_execute_time" show-overflow-tooltip label="任务产生时间" align="center">

            </el-table-column>
            <el-table-column prop="action" label="操作" align="center">
                <template slot-scope="scope">
                    <el-button type="text" size="small" @click="handleDetail(scope.row.task_id)">详情</el-button>
                    <el-button type="text" size="small" @click="handleRecord(scope.row.task_id)">记录</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="custom-pagination">
            <div class="info">
                <span>共 {{ total }} 条记录</span>
                <span>第 {{ query.page }} / {{ pageTotal }} 页</span>
            </div>
            <el-pagination
                background
                class="custom-page"
                layout="prev, pager, next, sizes"
                :page-sizes="[10, 20, 50, 100]"
                :current-page="query.page"
                :page-size="query.size"
                :total="total"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange">
            </el-pagination>
        </div>
    </div>
</template>

<script>
import { getJobs } from '@/api/job'
import { jobMixin } from '@/mixin/job'
import { resourceMixin } from '@/mixin/resource'
import { formatDate } from '@/utils/tool'
import {queryRuleList} from "@/api/random";

export default {
    computed: {
        pageTotal() {
            const page = Math.ceil(this.total / this.query.size)
            return page > 0 ? page : 1
        }
    },
    mixins: [jobMixin, resourceMixin],
    data () {
        return {
            loading: false,
            formData: {
                job_status: '',
                org: '',
                account: '',
                checkDate: '',
                company: '',
                limit: '',
                createDate: '',
                result: '',
            },
            query: {
                page: 1,
                size: 10,
                sort: "task_execute_time desc"
            },
            total: 0,
            tableData: []
        }
    },
    mounted () {
        this.handleQuery()
    },
    methods: {
        formatDate,
        resetForm(data) {
            this.query.query = data
            if (data && data.length > 0) {
                this.query.page = 1;
            }
            this.handleQuery()
        },
        handleSizeChange(val) {
            this.query.size = val
            this.handleQuery()
        },
        handleCurrentChange(val) {
            this.query.page = val
            this.handleQuery()
        },
        handleQuery() {
            this.loading = true
            let query = this.query.query || '';
            if (query.indexOf('task_type') < 0) {
                if (query.length > 0) {
                    query += ';';
                }
                query += 'task_type==0';
            }
            this.query.query = query;
            queryRuleList(this.query).then(res => {
              if (res) {
                this.total = res.total || 0
                const list = res.data || []
                list.map(item => {
                  item.task_execute_time = formatDate(item.task_execute_time, true)
                })
                this.tableData = list
              }
              this.loading = false
            })
        },
        handleDetail(id) {
            this.$router.push({
                path: '/random/random/rule/detail',
                query: {
                    id
                }
            })
        },
        handleRecord(id) {
            this.$router.push({
                path: '/random/random/check/record',
                query: {
                    id
                }
            })
        }
    }
}
</script>
